<?php
# api: phrep
# type: config
# title: Phrep local config
# description: Defines options, load macro helpers, predeclare macros
# config: { type: env list colon, name: PHP_INCLUDE_PATH, description: Include file search path }
#
# Supposed to reside in $HOME/.config/phrep/config.php
# Runs in ShellFlags::config context, with $opts and $proc available.
#

namespace macro;


// Load further ~/.config/phrep/*.php includes.
array_map([$this, "config"], glob(__DIR__."/*.php"));


// Set option defaults.
#$opts->force = 1;
#$proc->pragma["multipass"] = 10;


// Bind PHP_INCLUDE_PATH
if (!empty($_SERVER["PHP_INCLUDE_PATH"])) {
   $proc->p_dirs($_SERVER["PHP_INCLUDE_PATH"]);
}


