<?php
#pragma(output=0)


/**
 * Basic macros
 *
 */

#define FLOAT_EQUAL(f,g) (abs((f)-(g))<__FLT_EPSILON__)
#define MAX(a,b) ((a)>(b)?(a):(b))
#define SWAP(a,b) list(b,a) = array(a,b)


/**
 * Complex macros (AKA "shield operator" decorations)
 *
 */

#define IFSET@(expr)						\
  {  return "(isset($expr) ? $expr : NULL)";  }

#define NULLSAFE@(expr)						\
  $expr = preg_split("/\s*->\s*/", $expr);			\
  $r = "(\$_ = " . array_shift($expr) . ")";			\
  foreach ($expr as $x) {					\
    $r .= " and (\$_ = \$_->$x)";				\
  }								\
  return "($r ? \$_ : NULL)";

#define qw@(words)						\
  return "[" . join(", ",					\
     array_map(function($w) { return var_export($w, TRUE); },	\
       preg_split("/\s+/", trim(\io\Token::join($token))))	\
    ) . "]";


